#ifndef MAINTENANCE_H_
#define MAINTENANCE_H_

#include "config.h"
#include "meta.h"

class maintenance
{
public:
	maintenance(int fd);
	virtual ~maintenance();
	
	/// This method controls header/footer printing and termination
	/// Override only when really needed! Instead, use Action for contents of regular pages! 
	virtual void Run(const MYSTD::string &cmd)=0;

	bool m_bErrAbort;
	
protected:
	
	virtual void SendMsg(const MYSTD::string &x);
	virtual void SendMsg(const char *data, size_t size);
	bool _SendHelper(const char *data, size_t len, int flags);
	virtual void EndTransfer();
	MYSTD::string GetHostname();
	
	void SendDecoration(bool bBegin, const char *httpcode="200", const char *szDecoFile=NULL);
	void SetStyle(MYSTD::string&);
	int m_reportFD;
	const char *m_szDecoFile;
private:
	maintenance(const maintenance&);
	maintenance& operator=(const maintenance&);
};

class reportgen : public maintenance
{
public:
	reportgen(int);
	virtual void Run(const MYSTD::string &);
	virtual void GenReport();
};

void DispatchAndRunMaintTask(const MYSTD::string &, int, const char*);

#endif /*MAINTENANCE_H_*/
